// $Id: pdb.h,v 1.1.1.1 2002/11/16 16:02:44 halts Exp $
/** 
 * \class 	pdb::Tree, Section, Folder etc...
 * \brief	Pss DataBase ǗNXQ̒`
 * \author	Halts
 * \date	2001-2002
 * \warning database.pssdb4 ̉͗pɎgpĂB
 */

#ifndef ___PDB_H_INCLUDED_
#define ___PDB_H_INCLUDED_

#ifdef	WIN32
#	pragma warning(disable: 4786)
#endif

//----- include headers

#include <cstdio>				///< use stdio.h
#include <string>				///< use std::string<>
#include <vector>				///< use std::vector<>
#include <stack>				///< use std::stack<>
#include <cctype>				///< use ctype.h
#include "../../hcom/hcom.h"	///< use Halts Common Lib.


/// PssDatabase (for v3)
namespace pdb {

//----- `

class BaseElement;
class Section;
class Folder;
class Tree;
class Question;
class QuestionIndex;

//----- `

const static char* TAG_SECTION_BEGIN	= "<s>";				///< ZNV̊Jn^O
const static char* TAG_SECTION_END		= "</s>";				///< ZNV̏I^O
const static char* TAG_SECTION2_BEGIN	= "<s2>";				///< ZNV(v2)̊Jn^O
const static char* TAG_SECTION2_END		= "</s2>";				///< ZNV(v2)̏I^O
const static char* TAG_FOLDER_BEGIN		= "<f>";				///< tH_̊Jn^O
const static char* TAG_FOLDER_END		= "</f>";				///< tH_̏I^O
const static char* STR_DBVER_LEFT		= "# DatabaseVersion=";	///< PsڂDBVer̍
const static char* STR_DBVER_VER		= "4.0";				///< f[^x[Xo[W

const int N_ANSWERMAX					= 5;					///< PCɊ܂߂𓚐
const int N_QUESTIONMAX					= 2;					///< PCɊ܂߂萔
const int N_HINTMAX						= 3;					///< PCɊ܂߂qg


/// tH_GNX|[gt@CID
#define PSS_EXPORTFOLDER_ID			"# PssEditor FolderExportFile (.psf) "
/// tH_GNX|[gt@C̃o[W		\n
/// v2 ł́A<s2> ɑΉB
#define PSS_EXPORTFOLDER_VERSION	"v2"

/// ZNVGNX|[gt@CID
#define PSS_EXPORTSECTION_ID		"# PssEditor SectionExportFile (.pse) "
/// ZNVGNX|[gt@C̃o[W		\n
/// v2 ł́A<s2> ɑΉB
#define PSS_EXPORTSECTION_VERSION	"v2"


typedef const char*				CSTR;			///< 萔 (const char*)
typedef wchar_t*				CWSTR;			///< 萔 (UNICODE)
typedef std::string				String;			///< Pȕ
//typedef std::wstring			WString;		///< PȕiUNICODEj
typedef	String					PdbException;	///< PȗO
typedef std::vector<String>		Strings;		///< string-list for PssDB
//typedef std::vector<WString>	WStrings;		///< wstring-list for PssDB
typedef std::vector< Question >	Questions;		///< ̃Xg

//----- NX`


/**
 * f[^ǗNX
 */
class Question
{
public:
	//----- vars.
	Strings m_strQuestions;						///< f[^Q
	Strings m_strAnswers;						///< 𓚃f[^Q
	Strings m_strHints;							///< qgf[^Q
	String  m_strWavFile;						///< WAV t@C
	Strings m_strExtends;						///< gf[^io[WAbvpj

	//----- methods
	/// PȃRXgN^
	Question()
	{
		align();								// ̈m
		init();									// S
	}

/*	Question& operator = ( const Question& f_ )
	{
		align();
		init();
		m_strQuestions = f_.m_strQuestions;
		m_strAnswers = f_.m_strAnswers;
		m_strHints = f_.m_strHints;
		m_strExtend = f_.m_strExtend;
		m_strWavFile = f_.m_strWavFile;
		return *this;
	}
*/
	/// 2Zq ==
	bool operator == ( const Question& r_ )
	{
		if( m_strQuestions != r_.m_strQuestions )
			return false;
		if( m_strAnswers != r_.m_strAnswers )
			return false;
		if( m_strHints != r_.m_strHints )
			return false;
		if( m_strExtends != r_.m_strExtends )
			return false;
		if( m_strWavFile != r_.m_strWavFile )
			return false;
		return true;
	}

private:
	/// ̈̊m
	void align() {
		m_strQuestions.resize( N_QUESTIONMAX );
		m_strAnswers.resize( N_ANSWERMAX );
		m_strHints.resize( N_HINTMAX );
	}
public:

	/// o[̑S
	void init()
	{
		u_int i;
		for( i=0; i<m_strQuestions.size(); i++ ) 
			m_strQuestions[i] = "";
		for( i=0; i<m_strAnswers.size(); i++ )	 
			m_strAnswers[i] = "";
		for( i=0; i<m_strHints.size(); i++ )	 
			m_strHints[i] = "";
		m_strWavFile = "";
		m_strExtends.clear();
	}

	//--- n
	/// Empty ? 
	bool	isEmpty() const
	{
		u_int i;
		for( i=0; i<m_strQuestions.size(); i++ ) 
			if( m_strQuestions[i].empty() == false )
				return false;
		for( i=0; i<m_strAnswers.size(); i++ )	 
			if( m_strAnswers[i].empty() == false )
				return false;
		for( i=0; i<m_strHints.size(); i++ )	 
			if( m_strHints[i].empty() == false )
				return false;

		return m_strExtends.empty();
	}

	/// f[^ƂĐ藧Ă邩ǂ
	bool isQuestionLine() const
	{
		return ! isCommentLine();
	}

	/// f[^RgsƂĐ藧Ă邩ǂ
	bool isCommentLine() const
	{
		// 񓚃f[^[0]݂̂ŁÃf[^Ȃ΃Rgs
		u_int i=0;

		// f[^݂΁ARgsł͂ȂB
		for( i=0; i<m_strQuestions.size(); i++ ){
			if( m_strQuestions[i].empty() == false )
				return false;
		}
		// gf[^݂΁ARgsł͂ȂB
		if( m_strExtends.empty() == false )
			return false;
		// WAVt@C݂΁ARgsł͂ȂB
		if( m_strWavFile.empty() == false )
			return false;
		// qgf[^݂΁ARgsł͂ȂB
		for( i=0; i<m_strHints.size(); i++ ){
			if( m_strHints[i].empty() == false )
				return false;
		}
		// [0] ȊỎ𓚁i[1]`[n-1]j݂΁ARgsł͂ȂB
		for( i=1; i<m_strAnswers.size(); i++ ){
			if( m_strAnswers[i].empty() == false )
				return false;
		}

		// RgsB
		return true;
	}

	//--- Qƌn
	/// ̌ől
	int	nQuestionMax() const
	{
		return (int)m_strQuestions.size();
	}
	/// ̌JEg
	int	nQuestion() const
	{
		int n = 0;
		for( u_int i=0; i<m_strQuestions.size(); i++ )
			if( m_strQuestions[i].empty() == false ) n++;
		return n;
	}
	/// ̌̍ől
	int	nAnswerMax() const
	{
		return (int)m_strAnswers.size();
	}
	/// ̌JEg
	int	nAnswer() const
	{
		int n = 0;
		for( u_int i=0; i<m_strAnswers.size(); i++ )
			if( m_strAnswers[i].empty() == false ) n++;
		return n;
	}
	/// qǧ̍ől
	int	nHintMax() const
	{
		return (int)m_strHints.size();
	}
	/// qǧJEg
	int	nHint() const
	{
		int n = 0;
		for( u_int i=0; i<m_strHints.size(); i++ )
			if( m_strHints[i].empty() == false ) n++;
		return n;
	}
	/// gf[^̌
	int nExtends() const
	{
		return (int)m_strExtends.size();
	}


	/// Ō̋łȂvf̃CfbNX
	int	getLastAnswerIdx() const
	{
		int lastidx = 0;
		for( u_int i=0; i<m_strAnswers.size(); i++ ){
			if( m_strAnswers[i].empty() == false )
				lastidx = i;
		}
		return lastidx;
	}
	
	/// \ꐔJEg
	static int
	countWord( const String& a_str )
	{
		int n = 0;

		if( a_str.empty() )
			return n;
		String::const_iterator it = a_str.begin();

		while( it != a_str.end() && isSpace(*it) )	// skip spaces
			it++;

		while( it != a_str.end() ){
			n ++;

			// find next space or nul
			while( it != a_str.end() && isSpace(*it) == false ){
				it++;
			}
			if( it == a_str.end() )
				break;

			// Xy[XB
			it ++;

			while( it != a_str.end() && isSpace(*it) )	// skip spaces
				it++;
		}

		return n;
	}

	///  idx 擾
	const String&	getQuestion( int idx ) const
	{				
		if( idx<0 || idx >= N_QUESTIONMAX )
			throw PdbException("out of index (at getQuestion)");
		return m_strQuestions[idx];
	}
	///  idx 擾
	const String&	getAnswer( int idx ) const
	{
		if( idx<0 || idx >= N_ANSWERMAX )
			throw PdbException("out of index (at getAnswer)");
		return m_strAnswers[idx];
	}
	/// qg idx 擾
	const String&	getHint( int idx ) const
	{
		if( idx<0 || idx >= N_HINTMAX )
			throw PdbException("out of index (at getHint)");
		return m_strHints[idx];
	}
	/// g擾
	const String&	getExtendData( int idx ) const
	{
		if( idx<0 || idx >= (int)m_strExtends.size() )
			throw PdbException("out of index (at getExtend)");
		return m_strExtends[idx];
	}
	/// WAVt@C擾
	const String&	getWavFilename() const 
	{	return m_strWavFile;		}

	/**
	 * }NWJi%xxyXXXzjB
	 *
	 * @return
	 *	true		}NWJB\n
	 *	false		}NWJȂ
	 */
	static bool 
	expandMacro( String& a_strInOut )
	{
		int n=0;
#ifdef	LINUX
		// EUC ȂႾ߂Ȃ񂾂ǁAƂ肠pőΉĂB
		const char* szaMacros[] = {
			"[no.] ",
			"[ve.] ",
			"[a.] ",
			"[ad.] ",
			"[prep.] ",
			"[pron.] ",
			"[idiom] ",
			"[other] "
		};
#else
		// Windows ̃}NWJ
		const char* szaMacros[] = {
			"yz",
			"yz",
			"y`ez",
			"yz",
			"yOuz",
			"y㖼z",
			"ynz",
			"y̑z"
		};
#endif
		n += HReplaceString( a_strInOut, "%no", szaMacros[0] );
		n += HReplaceString( a_strInOut, "%ve", szaMacros[1] );
		n += HReplaceString( a_strInOut, "%aj", szaMacros[2] );
		n += HReplaceString( a_strInOut, "%ad", szaMacros[3] );
		n += HReplaceString( a_strInOut, "%av", szaMacros[3] );
		n += HReplaceString( a_strInOut, "%pp", szaMacros[4] );
		n += HReplaceString( a_strInOut, "%pn", szaMacros[5] );
		n += HReplaceString( a_strInOut, "%id", szaMacros[6] );
		n += HReplaceString( a_strInOut, "%ot", szaMacros[7] );

		return n==0 ? false : true;
	}

	/// }N̍폜
	static bool
	stripMacro( String& a_strInOut )
	{
		int n=0;
		n += HReplaceString( a_strInOut, "%no", "" );
		n += HReplaceString( a_strInOut, "%ve", "" );
		n += HReplaceString( a_strInOut, "%aj", "" );
		n += HReplaceString( a_strInOut, "%ad", "" );
		n += HReplaceString( a_strInOut, "%av", "" );
		n += HReplaceString( a_strInOut, "%pp", "" );
		n += HReplaceString( a_strInOut, "%pn", "" );
		n += HReplaceString( a_strInOut, "%id", "" );
		n += HReplaceString( a_strInOut, "%ot", "" );
		return n==0 ? false : true;
	}

	static bool isSpace( char ch )
	{
		if( ch == ' ' || ch == '\t' )
			return true;
		return false;
	}

};


/**
 * Section/Folder ̊NX
 */
class BaseElement
{
	//----- classes
public:
/**
 * manager of the attributes of Section/Folder
 */
class Attributes
{
public:
	enum ID_T {
		AUTHOR = 0,			///< 쌠
		WRITER = 1,			///< f[^͎
		BEGIN_MSG_JE = 2,	///< 񓚊JnbZ[W
		ENUM_MAX = 2,		///< ŏIlil傫΃G[j
	};
	
	//----- variables
protected:
	Strings				m_Attributes;	///< Q
	Strings				m_Notes;		///< l
										///< iQƂ͕ʎŁAzł邱ƂɒӁj
	//----- methods
public:
	/// RXgN^
	Attributes()
	{
		m_Attributes.resize( ENUM_MAX+1 );
		m_Notes.resize(0);
	}

	//--- ݒEQƌn
	CSTR getAuthor() const { return getAttribute( AUTHOR ); }			///< 쌠Җ̎擾
	CSTR getWriter() const { return getAttribute( WRITER ); }			///< ͎Җ̎擾
	CSTR getBeginMsg() const { return getAttribute( BEGIN_MSG_JE ); }	///< JnbZ[W̎擾
	void setAuthor( CSTR d_ ){ m_Attributes[ AUTHOR ] = d_; }			///< 쌠Җ̐ݒ
	void setWriter( CSTR d_ ){ m_Attributes[ WRITER ] = d_; }			///< ͎Җ̐ݒ
	void setBeginMsg( CSTR d_ ){ m_Attributes[ BEGIN_MSG_JE ] = d_; }	///< JnbZ[W̐ݒ
	
	/** 
	 * ̎擾
	 * @param a_type	̎
	 * @return			݂ȂƂ "" ԂB
	 */
	CSTR getAttribute( ID_T a_type ) const
	{
		if( 0 <= a_type && a_type < (int)m_Attributes.size() ){
			return m_Attributes[ a_type ].c_str();
		}else{
			return "";
		}
	}

	/**
	 * ̐ݒ
	 * @param a_type	̎
	 * @param a_str		ݒ肷镶
	 * @return			 true ԂB
	 */
	bool setAttribute( ID_T a_type, const String& a_str )
	{
		if( 0 <= a_type && a_type <= ENUM_MAX ){	// ͈͓
			m_Attributes[ a_type ] = a_str;			// ǉ
			return true;
		}
		// ͈͊OȂ̂ŃG[
		return false;
	}
	/**
	 * ̐ݒ
	 * @sa setAttribute
	 */
	bool setAttribute( ID_T a_type, CSTR a_str )
	{
		if( 0 <= a_type && a_type <= ENUM_MAX ){	// ͈͓
			m_Attributes[ a_type ] = a_str;			// ǉ
			return true;
		}
		// ͈͊OȂ̂ŃG[
		return false;
	}

	//--- l֘A
	/**
	 * l̐ݒ
	 * @param strNotes_	̃Xg
	 */
	bool setNotes( const Strings& strNotes_ )
	{
		m_Notes = strNotes_;
		return true;
	}
	/**
	 * l̐ݒB
	 * ͕\r\\n؂Ƃ݂ȂB
	 * @note	Qs܂łΉĂ܂B
	 */
	bool setNotesWithCR( CSTR szNotes_ )
	{
		m_Notes.resize( 0 );
		String strNotes( szNotes_ );

		int idx0 = 0;				// 
		int idx1 = 0;				// 
		while( (idx1=(int)strNotes.find("\r\n",idx0)) != (int)std::string::npos ){
			m_Notes.push_back( strNotes.substr( idx0, idx1-idx0 ) );
			idx0 = idx1+2;
		}
		String strLast = strNotes.substr( idx0 );
		if( strLast.empty() == false ){
			m_Notes.push_back( strLast );
		}

		return true;
	}

	/// l̒ǉB
	/// @note	擪 "note=" ͍폜ς݂łȂ΂ȂȂB
	bool addNotes( const String& strNote_ )
	{
		m_Notes.push_back( strNote_ );
		return true;
	}
	/// l̎擾B
	bool getNotes( Strings& strNotes_ )
	{
		strNotes_ = m_Notes;
		return true;
	}
	/// lf[^ \r\\n ؂̕ƂĎ擾B
	/// @note	Qs܂łΉĂ܂B
	bool getNotesWithCR( String& strNotes_ )
	{
		strNotes_ = "";

		for( u_int i=0; i<m_Notes.size(); i++ ){
			if( i > 0 )
				strNotes_ += "\r\n";
			strNotes_ += m_Notes[i];
		}
		return true;
	}

	/// t@Co
	bool writeTo( FILE* a_fp )
	{
		u_int i;
		for( i=0; i<ENUM_MAX+1; i++ ){
			fprintf( a_fp, "%s\n", m_Attributes[i].c_str() );
		}
		for( i=0; i<m_Notes.size(); i++ ){
			fprintf( a_fp, "note=%s\n", m_Notes[i].c_str() );
		}
		fprintf( a_fp, ".\n" );
		return true;
	}
};

	//----- variables
protected:
	String		m_Name;			///< ZNV
	Attributes		m_Attributes;	///< Q

	//----- methods
public:
	BaseElement(){}											///< RXgN^

	//--- ݒEQƌn
	Attributes& getAttributes(){ return m_Attributes; }			///< ̎QƂ̎擾
	const Attributes& getAttributes() const{ return m_Attributes; }			///< ̎QƂ̎擾
	void setAttributes( const Attributes& NewAttrib ){ m_Attributes = NewAttrib; }
																///< ̒u
	void setName( const String& a_str ){ m_Name = a_str; }	///< O̐ݒ
	void setName( CSTR a_str ){ m_Name = a_str; }			///< O̐ݒ
	const String& getName() const { return m_Name; }			///< O̎擾

	/// t@Co
	bool writeTo( FILE* a_fp )
	{
		fprintf( a_fp, "%s\n", m_Name.c_str() );	// ZNV̏o
		m_Attributes.writeTo( a_fp );				// ̏o

		return true;
	}
};

/**
 * ZNVǗNX
 */
class Section	: public BaseElement
{
	//----- classes
public:
/// Question <-> sf[^̕ϊ
class Parser
{
public:
	static inline bool	makeLine( const Question& q_, String& linebuf_ );	///< Input -> Line
	static inline bool	parseLine( Question& q_, CSTR a_line );				///< Line -> Input
	/// QuestionLine ?
	static bool isQuestionLine( CSTR a_line ) {
		return a_line[0] == '?' ? true : false;
	}
private:
	//----- private methods
	/// 
	static inline bool parse( Question& q_, CSTR a_line );
	static inline bool parseWQuotedString( const String& in, String::iterator it, String& buf );

	static inline bool TransStyle_Line2Input( String& buf );
	static inline bool TransStyle_Input2Line( String& buf );
	static inline bool parseQuestion( Question& q_, const String& in );
	static inline bool parseHint( Question& q_, const String& in );
};
	//----- variables
public:
	Questions	m_QuestionList;			///< f[^Q

	//----- methods
public:
	Section() {}									///< RXgN^
	
	/// f[^̍sԂB
	int nLines() const 
	{
//		return (int)m_Lines.size();
		return (int)m_QuestionList.size();
	}
	inline int nQuestionLines() const;				///< ƂėLȃf[^ԂB

	/// w肳ꂽsf[^ւ̎QƂԂB
	inline Question/*&*/ getQuestion( int a_idx ) const;

	/// f[^ a_str Ɠsf[^݂邩H
	bool hasQuestion( const Question& q_ ) {
//		String s;
//		Parser::makeLine( q_, s );
//		Strings::iterator it = std::find( m_Lines.begin(), m_Lines.end(), s );
//		if( it == m_Lines.end() ){

		Questions::iterator it = std::find( m_QuestionList.begin(), m_QuestionList.end(), q_ );
		if( it == m_QuestionList.end() ) {
			// not found
			return false;
		}else{
			// found
			return true;
		}
	}
	
	/// f[^̖ɍsf[^ǉB
	bool addQuestion( const Question& q_ )
	{
//		String str;
//		Parser::makeLine( q_, str );
//		m_Lines.push_back( str );
		m_QuestionList.push_back( q_ );
		return true;
	}

	/// w肳ꂽCfbNX̃f[^uB
	inline bool setQuestion( int idx_, const Question& q_ );

	/// w肳ꂽCfNX̃f[^폜B
	inline bool deleteLine( int a_idx );
	
	/// sf[^ׂč폜B
	void clearLines()
	{
//		m_Lines.clear();
		m_QuestionList.clear();
	}

	/**
	 * @brief w肳ꂽCfNXɃf[^ a_str }B
	 *
	 * CfNX̏ꍇ͉ false ԂB
	 * ۂɑ݂vf傫CfNXw肷ƁAɒǉB
	 * @warning ׂ傫̂ŒӁI
	 */
	inline bool insertQuestion( int a_idx, Question& q_ );
	/// t@Co
	inline bool writeTo( FILE* a_fp, int nVersion_ = 300 );

};

/**
 * tH_̗vf̃Xg
 * @note	vector  Element* ǗłȂ (auto_ptr) ̂ŁA삵B
 * @note	ƃGKgɋLq@B
 */
class ElementList
{
	//----- classes
public:
/**
 * tH_̗vfǗNX
 */
class Element
{
	//----- variables
public:
	/// vfID
	enum ID_T {
		SECTION,								///< ZNV
		FOLDER,									///< tH_
	};
	ID_T		m_Id;						///< ZNVȂ̂tH_Ȃ̂ ID
	BaseElement* m_Element;					///< tH_EZNVւ̃|C^
	
	//----- methods
public:
	/// constructor
	Element() : m_Id(SECTION), m_Element(NULL) {}
	inline ~Element();						///< destructor

	//--- \zn
	inline Folder& makeFolder();				///< tH_̍쐬
	inline Section& makeSection();			///< ZNV̍쐬

	//--- Qƌn
	/// tH_̎Q
	Folder& getFolder()
	{
		if( m_Id == FOLDER )
			return *(Folder*)m_Element;
		throw PdbException( "not folder" );
	}
	/// ZNV̎Q
	Section& getSection()
	{
		if( m_Id == SECTION )
			return *(Section*)m_Element;
		throw PdbException( "not section" );
	}

	//--- n
	/// tH_ǂ̃`FbN
	/// @return tH_ł true ԂB
	bool isFolder(){	return m_Id == FOLDER ? true : false;	}
	/// ZNVł邩ǂ̃`FbN
	/// @return ZNVł true ԂB
	bool isSection(){	return m_Id == SECTION ? true : false;	}

	/// 
	Element& operator = ( const Element& a_from );

	/// t@Co
	inline bool writeTo( FILE* a_fp, int nVersion_ = 300 );
};

	//----- variables
public:
	Element*			m_ElementArray;		///< vf̃Xg
	int					m_nSize;			///< Xg̗vf
	int					m_nCapacity;		///< eʁiőeʁj
	int					m_nAllocateSize;	///< AP[gTCYi萔j

	//----- methods
public:
	ElementList() 
		: m_ElementArray( NULL ), 
		  m_nSize(0),
		  m_nCapacity(0),
		  m_nAllocateSize(20)				// 萔
	{}										///< RXgN^
	~ElementList()
	{
		if( m_ElementArray )
			delete[] m_ElementArray;
	}										///< fXgN^

	/// TCYύX
	void resize( int a_size )
	{
		if( a_size > m_nCapacity ){
			//--- Ȃ̂ōĊm

			// AP[g
			int newsize;	// AP[gTCY		
			if( a_size % m_nAllocateSize == 0 ){
				//  m_nAllocateSize * n ɂȂB
				newsize = m_nAllocateSize * ( a_size / m_nAllocateSize );
			}else{
				// m_nAllocateSize * (n+1) KvB
				newsize = m_nAllocateSize * ( a_size / m_nAllocateSize +1 );
			}
			Element* NewElements = new Element[ newsize ];

			// Rs[
			for( int i=0; i<m_nSize; i++ ){
				NewElements[i] = m_ElementArray[i];
			}

			// 
			delete[] m_ElementArray;

			// o[̍XV
			m_ElementArray = NewElements;
			m_nSize = a_size;
			m_nCapacity = newsize;
			return;
		}

		//--- Ă̂ŃTCYς邾B
		m_nSize = a_size;
	}

	/// TCYQ
	int size(){
		return m_nSize;
	}

	/// e(allocated-size = capacity)Q
	int capacity(){
		return m_nCapacity;
	}


	/// t@Co
	inline bool writeTo( FILE* a_fp, int nVersion_ = 300 ){
		for( int i=0; i<m_nSize; i++ ){
			m_ElementArray[i].writeTo( a_fp, nVersion_ );
		}
		return true;
	}

	/// Q
	Element& operator [] ( int a_idx ){
		return m_ElementArray[a_idx];
	}

	/// 
	ElementList& operator = ( const ElementList& a_from ){
		int n = a_from.m_nSize;
		Element* ElementFrom = a_from.m_ElementArray;

		resize( n );
		for( int i=0; i<n; i++ ){
			m_ElementArray[i] = ElementFrom[i];
		}

		return *this;
	}
	
	/**
	 * @brief 폜
	 *
	 * iԖڂn̗vf폜
	 */
	bool erase( int a_i, int a_n=1 ){
		if( a_i < 0 || a_i >= m_nSize ){
			// sȃCfNX
			return false;
		}

		// m_ElementArray  i  i+(n-1) ̗vfɑ΂ăfXgN^ĂяoB
		int j;
		for( j=a_i; j<a_i+a_n; j++ ){
			m_ElementArray[j].~Element();
		}

		// ۂɈړB
		memmove( 
			m_ElementArray +a_i, 
			m_ElementArray +a_i+a_n, 
			sizeof( Element ) * (m_nSize -(a_i+a_n)) );

		// Ō̕ɂ܂ a_n ̗vfB
		for( j=0; j<a_n; j++ ){
			m_ElementArray[m_nSize-1-j].m_Element = NULL;	// |C^ɂȂȂ̂ŏ
			m_ElementArray[m_nSize-1-j].m_Id = Element::FOLDER;
		}

		m_nSize = m_nSize -a_n;

		return true;
	}
};



/**
 * tH_ǗNX
 */
class Folder		: public BaseElement
{
	//----- variables
protected:
	ElementList	m_Elements;		///< vfQ

	//----- methods
public:
	Folder(){}

	/// ZNV̐VK쐬
	/// @note Ԃlɑ΂ēK؂ȏKvB
	Section& addSection()
	{
		int n = m_Elements.size();
		m_Elements.resize( n+1 );
		Section& newSection = m_Elements[n].makeSection();
		return newSection;
	}

	/// tH_̐VK쐬
	/// @note Ԃlɑ΂ēK؂ȏKvB
	Folder& addFolder()
	{
		int n = m_Elements.size();
		m_Elements.resize( n+1 );
		Folder& newFolder = m_Elements[n].makeFolder();
		return newFolder;
	}

	//--- o͌n

	/// wb_[܂߂ďo
	bool writeTo( FILE* a_fp, int nVersion_ = 300 )
	{
		fprintf( a_fp, "%s\n", TAG_FOLDER_BEGIN );	// tH_JnL ̏o
		BaseElement::writeTo( a_fp );				// OȀo

		writeTo_withoutHeader( a_fp, nVersion_ );	// wb_[ȊO̕o

		fprintf( a_fp, "%s\n\n", TAG_FOLDER_END );	// tH_IL ̏o

		return true;
	}

	/// wb_[ďo
	bool writeTo_withoutHeader( FILE* a_fp, int nVersion_ = 300 )
	{
		m_Elements.writeTo( a_fp, nVersion_ );					// tH_̗vf̏o
		return true;
	}

	//--- n

private:
	/// tH_̎擾
	/// @throw PdbException
	/// @note ݂ȂΗO throw B
	Folder& getFolder_atThisPoint( const String& a_FolderName )
	{
		int n = m_Elements.size();
		for( int i=0; i<n; i++ ){
			if( m_Elements[i].isFolder() &&
				m_Elements[i].getFolder().getName() == a_FolderName )
			{
				return m_Elements[i].getFolder();	// I
			}
		}
		throw "";
	}

public:
	/// tH_̎擾
	/// @throw PdbException
	/// @note ݂ȂΗO throw B
	inline Folder& getFolder( const String& a_Path );
	/// tH_̎擾
	/// @throw PdbException
	/// @note ݂ȂΗO throw B
	Folder& getFolder( CSTR a_Path ){
		String Path( a_Path );
		return getFolder( Path );
	}

private:
	/// ZNV̎擾
	/// @throw Exception
	/// @note ݂ȂΗO throw B
	Section& getSection_atThisPoint( const String& a_SectionName )
	{
		int n = m_Elements.size();
		for( int i=0; i<n; i++ ){
			if( m_Elements[i].isSection() &&
				m_Elements[i].getSection().getName() == a_SectionName )
			{
				return m_Elements[i].getSection();	// I
			}
		}
		throw "";
	}

public:
	/// ZNV̎擾iCfbNXwj
	Section& getSection( int idx_ )
	{
		int n = m_Elements.size();
		int idxc = 0;
		for( int i=0; i<n; i++ ) {
			if( m_Elements[i].isSection() ) {
				if( idxc == idx_ ) {
					return m_Elements[i].getSection();	// 
				}
				idxc++;
			}
		}
		throw "not found...";
	}

	/// tH_̎擾iCfbNXwj
	Folder& getFolder( int idx_ )
	{
		int n = m_Elements.size();
		int idxc = 0;
		for( int i=0; i<n; i++ ) {
			if( m_Elements[i].isFolder() ) {
				if( idxc == idx_ ) {
					return m_Elements[i].getFolder();	// 
				}
				idxc++;
			}
		}
		throw "not found...";
	}


	/// ZNV̎擾
	/// @note ݂ȂΗO throw B
	inline Section& getSection( const String& a_Path );
	/// ZNV̎擾
	/// @note ݂ȂΗO throw B
	Section& getSection( CSTR a_Path )
	{
		String Path( a_Path );
		return getSection( Path );
	}

	/// tH_̍ŏ̃ZNV擾
	Section& getFirstSection()
	{
		int n = m_Elements.size();
		for( int i=0; i<n; i++ ){
			if( m_Elements[i].isSection() )
			{
				return m_Elements[i].getSection();	// I
			}
		}
		throw "";
	}
	/// tH_ BeforeSection ̎̃ZNV擾
	Section& getNextSection( const Section& BeforeSection );
	/// tH_̍ŏ̃tH_擾
	Folder& getFirstFolder()
	{
		int n = m_Elements.size();
		for( int i=0; i<n; i++ ){
			if( m_Elements[i].isFolder() )
			{
				return m_Elements[i].getFolder();	// I
			}
		}
		throw "";
	}
	/// tH_ BeforeFolder ̎̃tH_擾
	Folder& getNextFolder( const Folder& BeforeFolder );

	/// tH_̑݊mF
	bool hasFolder( const String& a_Path )
	{
		try{
			getFolder( a_Path );
		}catch(...){
			// tH_B
			return false;
		}
		// tH_B
		return true;
	}
	/// tH_̑݊mF
	bool hasFolder( CSTR a_Path )
	{
		String Path( a_Path );
		return hasFolder( Path );
	}

	/// ZNV̑݊mF
	bool hasSection( const String& a_Path )
	{
		try{
			getSection( a_Path );
		}catch(...){
			// ZNVB
			return false;
		}
		// ZNVB
		return true;
	}
	/// ZNV̑݊mF
	bool hasSection( CSTR a_Path )
	{
		String Path( a_Path );
		return hasSection( Path );
	}

	//--- 폜n
	/// ̃tH_ZNV a_Path 폜B
	/// @param a_Path	pXwłB
	inline bool deleteSection( CSTR a_Path );

	/// ̃tH_ZNV a_Name 폜B
	/// @param a_Name	pX͎włȂB
	bool deleteSection_atThisPoint( String& a_Name )
	{
		int n = m_Elements.size();
		for( int i=0; i<n; i++ ){
			if( m_Elements[i].isSection() ){
				if( m_Elements[i].getSection().getName() == a_Name ){
					// m_Elements[i] 폜B
					return m_Elements.erase( i );
				}
			}
		}
		return false;
	}

	/// ̃tH_tH_ a_Name 폜B
	/// @param a_Name	pX͎włȂB
	bool deleteFolder_atThisPoint( String& a_Name )
	{
		int n = m_Elements.size();
		for( int i=0; i<n; i++ ){
			if( m_Elements[i].isFolder() ){
				if( m_Elements[i].getFolder().getName() == a_Name ){
					// m_Elements[i] 폜B
					return m_Elements.erase( i );
				}
			}
		}
		return false;
	}

	/// ̃tH_tH_ a_Path 폜B
	/// @param a_Path	pXwłB
	inline bool deleteFolder( CSTR a_Path );

	/// S폜
	void clear()
	{
		m_Elements.resize( 0 );
	}

	/// ڎQ
	ElementList& getRawElements()
	{
		return m_Elements;
	}
	
private:
	/**
	 * f[^x[XŃj[NȃpX𐶐B
	 *
	 * O݂A(1)`(99) 𖖔ɒǉB
	 * @return ł true, łȂ false ԂB
	 * @param a_NewPath		VpX
	 * @param a_OrgPath		̃pX
	 * @param a_bMakeFolder	tH_pX̐ǂw肷B
	 */
	bool makeUniquePath( String& a_NewPath, const String& a_OrgPath, bool a_bMakeFolder )
	{
		bool bExist;

		// ݃`FbN
		if( a_bMakeFolder )
			bExist = hasFolder( a_OrgPath );
		else
			bExist = hasSection( a_OrgPath );

		if( bExist ){
			// ZNV̓tH_݂̂ŁAVO쐬B
			String strNewPath;		// VpX̌
			for( int i=1; i<100; i++ ){
				strNewPath = a_OrgPath;
				strNewPath += " (";
				char szNum[16] = "";
				sprintf( szNum, "%d", i );
				strNewPath += szNum;
				strNewPath += ")";
//+				wsprintf( buf, "%s (%d)", pszOldPath, n );

				// ݃`FbN
				if( a_bMakeFolder )
					bExist = hasFolder( strNewPath );
				else
					bExist = hasSection( strNewPath );

				if( bExist == false ){
					// ݂Ȃ̂ŖOmI
					a_NewPath = strNewPath;
					return true;
				}
			}
			return false;
		}else{
			a_NewPath = a_OrgPath;
			return true;
		}
	}
public:

	/// f[^x[XŃj[NȃtH_pX𐶐B
	///
	/// O݂A(1)`(99) 𖖔ɒǉB
	/// @return ł true, łȂ false ԂB
	/// @param a_NewPath	VpX
	/// @param a_OrgPath	̃pX
	bool makeUniqueFolderPath( String& a_NewPath, const String& a_OrgPath )
	{
		return makeUniquePath( a_NewPath, a_OrgPath, true );
	}

	/// f[^x[XŃj[NȃZNVpX𐶐B
	///
	/// O݂A(1)`(99) 𖖔ɒǉB
	/// @return ł true, łȂ false ԂB
	/// @param a_NewPath	VpX
	/// @param a_OrgPath	̃pX
	bool makeUniqueSectionPath( String& a_NewPath, const String& a_OrgPath )
	{
		return makeUniquePath( a_NewPath, a_OrgPath, false );
	}
};

/**
 * f[^x[X̂̂̃c[\ǗNX
 *
 * t@CƂ̓o͂\B
 */
class Tree : public Folder
{
	//----- variables
private:
	Strings		m_Header;		///< t@C̃wb_[

	//----- methods
public:
	Tree(){}

	/// Q
	Strings&	getHeader(){	return m_Header;	}

	/// 폜
	void clear(){
		m_Header.clear();
		Folder::clear();
	}


	/// f[^x[Xt@C a_filename ǂݍށB
	/// @return  true ԂB
	bool readTree( CSTR a_filename )
	{
		FILE* fp;
		if( (fp=fopen(a_filename,"r")) == NULL ){
			return false;
		}
		bool r = readTree(fp);
		fclose(fp);
		return r;
	}

	/// f[^x[Xt@C fp ǂݍށB
	/// @return  true ԂB
	inline bool readTree( FILE* a_fp );

	/// f[^x[Xt@CVK쐬B
	/// @return  true ԂB
	bool createNew( CSTR a_filename, int nVersion_ = 300 )
	{
		FILE* fp;

		if( (fp=fopen(a_filename,"w")) == NULL ){
			return false;
		}
		fclose( fp );
		return true;
	}

	/**
	 * f[^x[X fp ɏóB
	 *
	 * o[W 400 w肷ƁAZNV <s2> `ŏo͂B
	 * @param	nVersion	f[^x[X̃o[Ww肷B{300(3.0), 400(4.0)}
	 * @return  true ԂB
	 */
	bool writeTree( FILE* a_fp, int nVersion_ = 300 )
	{
		// m_Header ̏o
		Strings::const_iterator it	   = m_Header.begin();
		Strings::const_iterator it_end = m_Header.end();
		for( ; it != it_end; it++ ) {
			const String& str = (*it);

			// o[W̏
			if( it == m_Header.begin() ) {
				fprintf( a_fp, "%s%s\n", STR_DBVER_LEFT, STR_DBVER_VER );
				if( strncmp( str.c_str(), STR_DBVER_LEFT, 10 ) == 0 ) {
					continue;
				}else{
				}
			}

			fputs( str.c_str(), a_fp );
			fputc( '\n', a_fp );
		}

		// m_Root ̏o
		// [gtH_Ɋւwb_[o͂Ȃ̂ŁAwithout gpB
		writeTo_withoutHeader( a_fp, nVersion_ );

		return true;
	}

	/// f[^x[Xt@C a_filename ɏóB
	/// @return  true ԂB
	bool writeTree( CSTR a_filename, int nVersion_ = 300 )
	{
		FILE* fp;
		if( (fp=fopen(a_filename,"w")) == NULL ){
			return false;
		}
		bool r = writeTree( fp, nVersion_ );
		fclose(fp);
		return r;
	}

private:
	/**
	 * t@Cւ̃GNX|[g
	 *
	 * @param pszExportFilepath_	GNX|[gt@C
	 * @param pszElementPath_		vf̃pX
	 * @param bFolder_				tH_ǂwB
	 * @throw PdbException
	 * @todo	G[SȂ悤B
	 */
	void exportFile( CSTR pszExportFilepath_, CSTR pszElementPath_, bool bFolder_ )
	{
		// t@C݂ꍇA폜i㏑j
		if( HFileExist( pszExportFilepath_ ) ){
			unlink( pszExportFilepath_ );
		}

		// f[^x[Xt@CƂč\B
		// f[^x[Xt@CVK쐬B
		Tree outdb;
		if( outdb.createNew( pszExportFilepath_ ) == false ){
			throw PdbException( "t@C̍쐬Ɏs܂cB" );
		}
		
		// ۂ̏o͍ƁitH_ƃZNVŕʂ̏sj
		if( bFolder_ ){
			//--- tH_̏o͍
			Folder& NewFolder = outdb.addFolder();

			//--- t@CIDo͂B
			String str;
			// ID
			str = PSS_EXPORTFOLDER_ID;
			str += PSS_EXPORTFOLDER_VERSION;
			outdb.getHeader().push_back( str );

			// path
			str = "# path = ";
			str += pszElementPath_;
			outdb.getHeader().push_back( str );
			str = "# ";
			outdb.getHeader().push_back( str );

			// tH_[Rs[B
			NewFolder = getFolder( pszElementPath_ );
		}else{
			//--- ZNV̏o͍
			Section& secNew = outdb.addSection();

			//--- ZNVt@CIDo͂B
			String str;
			// ID
			str = PSS_EXPORTSECTION_ID;
			str += PSS_EXPORTSECTION_VERSION;
			outdb.getHeader().push_back( str );

			// path
			str = "# path = ";
			str += pszElementPath_;
			outdb.getHeader().push_back( str );
			str = "# ";
			outdb.getHeader().push_back( str );
			
			// ZNVRs[B
			secNew = getSection( pszElementPath_ );
		}
		outdb.writeTree( pszExportFilepath_ );
	}

public:
	/**
	 * t@Cւ̃ZNṼGNX|[g
	 *
	 * @param pszExportFilepath_	GNX|[gt@C
	 * @param pszSectionPath_		vf̃pX
	 */
	void exportSection( CSTR pszExportFilepath_, CSTR pszSectionPath_ )
	{
		exportFile( pszExportFilepath_, pszSectionPath_, false );
	}

	/**
	 * t@Cւ̃tH_̃GNX|[g
	 *
	 * @param pszExportFilepath_	GNX|[gt@C
	 * @param pszFolderPath_		vf̃pX
	 */
	void exportFolder( CSTR pszExportFilepath_, CSTR pszFolderPath_ )
	{
		exportFile( pszExportFilepath_, pszFolderPath_, true );
	}

	//--- C|[g֘A

	/**
	 * ZNVt@C a_pszImportFile  a_pszImportFolderAt ɒǉB
	 *
	 * a_pszImportFolderAt  NULL ̏ꍇA[gɍ쐬B
	 * @return  true ԂB
	 * @param a_pszImportFile		C|[gt@C
	 * @param a_pszImportFolderAt	C|[gtH_pXiNULL̏ꍇA[gɍ쐬j
	 */
	bool importSection( CSTR a_pszImportFile, CSTR a_pszImportFolderAt )
	{
		Tree idb;	// C|[g
		if( idb.readTree( a_pszImportFile ) == false )
			return false;

		try{
			Folder* pInsertFolder = NULL;		// C|[g̃tH_
			if( a_pszImportFolderAt == NULL ){
				pInsertFolder = this;
			}else{
				pInsertFolder = &getFolder( a_pszImportFolderAt );
			}

			// ǉ̃ZNV쐬B
			Section& NewSection = pInsertFolder->addSection();

			// C|[g̃ZNV擾
			Section& FromSection = idb.getFirstSection();

			// C|[gɓO邩mFAC|[g̖O쐬B
			String NewName;
			pInsertFolder->makeUniqueSectionPath( NewName, FromSection.getName() );
			// Rs[
			NewSection = FromSection;

			// O̐ݒ
			NewSection.setName( NewName );

			return true;
		}catch( ... ){
			return false;
		}
	}
	/**
	 * tH_t@C a_pszImportFile  a_pszImportFolderAt ɒǉB
	 *
	 * a_pszImportFolderAt  NULL ̏ꍇA[gɍ쐬B
	 * @return  true ԂB
	 * @param a_pszImportFile		C|[gt@C
	 * @param a_pszImportFolderAt	C|[gtH_pXiNULL̏ꍇA[gɍ쐬j
	 */
	bool importFolder( CSTR a_pszImportFile, CSTR a_pszImportFolderAt )
	{
		Tree idb;	// C|[g
		if( idb.readTree( a_pszImportFile ) == false )
			return false;

		try{
			Folder* pInsertFolder = NULL;		// C|[g̃tH_
			if( a_pszImportFolderAt == NULL ){
				pInsertFolder = this;
			}else{
				pInsertFolder = &getFolder( a_pszImportFolderAt );
			}

			// ǉ̃ZNV쐬B
			Folder& NewFolder = pInsertFolder->addFolder();

			// C|[g̃ZNV擾
			Folder& FromFolder = idb.getFirstFolder();

			// C|[gɓO邩mFAC|[g̖O쐬B
			String NewName;
			pInsertFolder->makeUniqueFolderPath( NewName, FromFolder.getName() );
			// Rs[
			NewFolder = FromFolder;

			// O̐ݒ
			NewFolder.setName( NewName );

			return true;
		}catch( ... ){
			return false;
		}
	}

	//----- static methods
	
	/// szPath  '/' ̍ strLeft_ ƉE strRight_ ɕB
	/// '/' ͑OvB
	static bool splitPathForward( CSTR szPath_, String& strLeft_, String& strRight_ )
	{
		return splitPathForward( String(szPath_), strLeft_, strRight_ );
	}
	/// @sa splitPathForward
	static bool splitPathForward( const String& strPath_, String& strLeft_, String& strRight_ )
	{
		size_t findidx = strPath_.find('/');
		if( findidx == strPath_.npos ){
			// '/' pXɊ܂܂ĂȂ
			return false;
		}
		// '/' pXɊ܂܂Ă̂ŁA'/' ̑O(strLeft_) ƌ(strRight_) ɕB
		strLeft_  = strPath_.substr( 0, findidx );
		strRight_ = strPath_.substr( findidx+1 );
		return true;
	}

	/**
	 * szPath_  tH_ strFolder_ ƃZNV strSection_ ɕB
	 * ܂A'/' vŒTA̍ strFolder_ AE strSection_ 
	 * ƂB
	 *
	 * @param szPath_		̓pXB			F"ahi/ihi/AHI"
	 * @param strFolder_	͌̃tH_B	F"ahi/ihi"
	 * @param strSection_	͌̃ZNVB	F"AHI"
	 */
	static bool splitPath2FolderSection( 
		CSTR szPath_, String& strFolder_, String& strSection_ )
	{
		return splitPath2FolderSection( String(szPath_), strFolder_, strSection_ );
	}
	/// @sa splitPath2FolderSection
	static bool splitPath2FolderSection( 
		const String strPath_, String& strFolder_, String& strSection_ )
	{
		size_t findidx = strPath_.rfind('/');
		if( findidx == strPath_.npos ){
			// '/' pXɊ܂܂ĂȂ
			return false;
		}
		// '/' pXɊ܂܂ĂB
		// '/' ̑OtH_ƂB
		strFolder_  = strPath_.substr( 0, findidx );
		// '/' ̌ZNVƂB
		strSection_ = strPath_.substr( findidx+1 );
		return true;
	}
};


/**
 * W\CfbNXW
 *
 * Section ւ̃CfbNXWłB
 * ܂񓚂ĂȂ͂ǂꂩAǂ̖ԈAȂǂ̏̊ǗɗpB
 */
class QuestionIndex
{
public:
	//----- members
	std::deque<int> index_;							///< CfbNXW

public:
	//----- methods

	/// ZNVCfbNXWB
	inline bool makeIndex( const Section& sec_ );

	/// CfbNXWVbtB
	void shuffle(){
		std::random_shuffle( index_.begin(), index_.end() );
	}

	/// f[^ idx_ 邩ǂ̃`FbN
	bool has( int idx_ ){
		std::deque<int>::iterator r = std::find( index_.begin(), index_.end(), idx_ );
		if( r == index_.end() )
			return false;	// not found
		return true;
	}

	/// vf i_ 擾B
	int get( u_int i_ ) const {
		if( index_.empty() ) return -1;
		if( i_ < 0 || i_ >= index_.size() ) return -1;
		return index_[i_];
	}

	/// data_ ł鍀ڂ̃CfbNXTB
	int rget( u_int data_ ){
		if( index_.empty() ) return -1;
		for( u_int i=0; i<index_.size(); i++ ){
			if( index_[i] == (int)data_ )
				return i;
		}
		return -1;
	}

	/// _Ɉ̃CfbNXoA̗vf폜B
	int popRandom(){
		if( index_.empty() )
			return -1;
		size_t idx = rand() % index_.size();

		int r = index_[ idx ];
		index_.erase( index_.begin() + idx );

		return r;
	}

	/// ̖̃CfbNXԂBۂɂ̓Xg̍ŏ̗vfԂB
	/// s -1 ԂB
	int getFirstIndex(){
		if( index_.empty() )
			return -1;
		return *index_.begin();
	}

	int size() const { return (int)index_.size(); }		///< 傫Ԃ
	void clear(){ index_.clear(); }					///< S폜

	/// ŏ̗vf폜B
	bool popFront()
	{
		index_.pop_front();
		return true;
	}

	/// idx_ ǉB
	void add( int idx_ ){
		index_.push_back( idx_ );
	}

	/// \[g
	bool sort( bool (*compare_func_)(int l,int r) ){
		std::sort( index_.begin(), index_.end(), compare_func_ );
		return true;
	}

	/// idx_ 폜B
	bool erase( int idx_ ){
		if( idx_ < 0 || idx_ >= size() ) return false;
		index_.erase( index_.begin()+idx_ );
		return true;
	}
};



//----- implementations for inline-methods

/// destructor
inline 
ElementList::Element::~Element()
{
	if( m_Id == SECTION ){
		if( m_Element != NULL ){
			delete m_Element;
			m_Element = NULL;
		}
	}else{
		if( m_Element != NULL ){
			delete m_Element;
			m_Element = NULL;
		}
	}
}

/// t@Co
inline bool 
ElementList::Element::writeTo( FILE* a_fp, int nVersion_/* = 300*/ )
{
	if( m_Id == FOLDER ){
		if( m_Element )
			return (*(Folder*)m_Element).writeTo( a_fp, nVersion_ );
	}
	else{
		if( m_Element )
			return (*(Section*)m_Element).writeTo( a_fp, nVersion_ );
	}
	return false;
}

/// tH_̍쐬
inline Folder& 
ElementList::Element::makeFolder()
{
	m_Id = FOLDER;
	m_Element = new Folder();
	return *(Folder*)m_Element;
}

/// ZNV̍쐬
inline Section& 
ElementList::Element::makeSection()
{
	m_Id = SECTION;
	m_Element = new Section();
	return *(Section*)m_Element;
}

/// ƂėLȃf[^ԂB
inline int 
Section::nQuestionLines() const
{
	size_t nMax = m_QuestionList.size();
	int n = 0;
	for( size_t i=0; i<nMax; i++ ){
//		if( Section::Parser::isQuestionLine( m_Lines[i].c_str() ) )
		if( m_QuestionList[i].isQuestionLine() )
			n++;
	}
	return n;
}

/// ZNV̎擾
inline Section& 
Folder::getSection( const String& a_Path )
{
#define	GETSECTION_EXCEPTION_STRING		"section " + a_Path + "not found."
	String strFolder, strSection;
	if( Tree::splitPath2FolderSection( 
			a_Path, strFolder, strSection ) == false )
	{
		// '/' pXɊ܂܂ĂȂ̂ŁÃtH_Ɋ܂܂ĂB
		try{
			return getSection_atThisPoint( a_Path );
		}catch(...){
			throw PdbException( GETSECTION_EXCEPTION_STRING );
		}
	}
	// strFolder ̃tH_ɑ݂邩ǂ𒲂ׂB
	try{
		Folder& BaseFolder = getFolder( strFolder );

		// ̃tH_AstrSection B
		try{
			return BaseFolder.getSection( strSection );
		}catch(...){
			throw PdbException( GETSECTION_EXCEPTION_STRING );
		}
	}catch(...){
		// tH_݂Ȃ̂ŁAO𓊂B
		throw PdbException( GETSECTION_EXCEPTION_STRING );
	}
}

inline bool 
Folder::deleteSection( CSTR a_Path )
{
	String strPath( a_Path );
	String strFolder, strSection;	// 

	if( Tree::splitPath2FolderSection(
			strPath, strFolder, strSection ) == false )
	{
		// '/' ݂Ȃ̂ŁÃtH_ɑ݂B
		return deleteSection_atThisPoint( strPath );
	}

	try{
		getFolder( strFolder ).deleteSection_atThisPoint( strSection );
	}catch( PdbException e ){
		throw PdbException( "error (" + e + "(in deleteSection " + strPath + " )" );
	}

	return true;
}

inline bool 
Folder::deleteFolder( CSTR a_Path )
{
	String strPath( a_Path );
	String strFolder, strElement;	// 

	if( Tree::splitPath2FolderSection(
			strPath, strFolder, strElement ) == false )
	{
		// '/' ݂Ȃ̂ŁÃtH_ɑ݂B
		return deleteFolder_atThisPoint( strPath );
	}
	try{
		getFolder( strFolder ).deleteFolder_atThisPoint( strElement );
	}catch( PdbException e ){
		throw PdbException( "error (" + e + "(in deleteFolder " + strPath + " )" );
	}

	return true;
}

/**
 * f[^x[Xt@C fp ǂݍށB
 *
 * Ԃ pdb.h ōłdvȏB
 */
inline bool 
Tree::readTree( FILE* a_fp )
{
	//--- ReadTree p}NR}h
#define	HEADCMP( x, y )			( strncmp(x,y,strlen(y))==0 )			///< 擪v
#define RT_NEWLINE()			( pRet=fgets(&buf[0],BUF_MAX,a_fp) )	///< Vs̃tFb`
#define RT_HCOMP_MAKELOWERBUF()	\
								HChomp( &buf[0] );			\
								HLowerString( &buf[0], strBufLwr )		///< Psǂݍ݌̏
#define	BUF_START_WITH(y)		( HEADCMP( strBufLwr.c_str(), y ) )		///< strBufLwr  y Ŏn܂΁B

	//--- ԌQ
	enum STATUS{
		READ_HEADER,			///< t@C̃wb_[ǂݍݏ
		READ_FOLDER,			///< tH_̃wb_[ǂݍݏ
		READ_FOLDER_CONTENTS,	///< tH_̓eǂݍݏ
		READ_SECTION,			///< ZNṼwb_[ǂݍݏ
		READ_SECTION_CONTENTS,	///< ZNV̓eǂݍݏ
		READ_SECTION2,			///< ZNV(v2)̃wb_[ǂݍݏ
		READ_SECTION2_CONTENTS,	///< ZNV(v2)̓eǂݍݏ
		READ_ROOT,				///< READ_FOLDER, READ_SECTION ̌̃[gtH_ȉ̌
	};

	//--- ^Cv`
	typedef std::stack<Folder*>	FOLDER_STACK;			// tH_pX^bÑ^Cv`

	//--- ϐ
	STATUS				status = READ_HEADER;			// 
	const static int	BUF_MAX = 1024;					// obt@TCY
	std::vector<char>	buf( BUF_MAX );					// ǂݍ݃obt@
	char*				pRet = NULL;					// RT_NEWLINE() ̕ԂlBNULL ȂG[
	String				strBufLwr;						//  buf 
	FOLDER_STACK		FolderStack;					// Folder-stack for READ_FOLDER
	Section*			pSection = NULL;				// Section pointer for READ_SECTION
	String				strException = "illegal EOF found... ";	// EOF O̊{

	//--- 
	int iHeader=0;											// t@Cwb_[͔̓ԍ

	while( RT_NEWLINE() != NULL ){							// Vs̃tFb`
		RT_HCOMP_MAKELOWERBUF();									// buf ̐`  strBufLwr ̍쐬

		switch(status){
		case READ_HEADER:									// wb_[͏
		case READ_ROOT:										// [gtH_͏
			// <s>, <s2>, <f>  ԑJ

			if( BUF_START_WITH( TAG_SECTION_BEGIN ) ){		// ZNVJn
				status = READ_SECTION;						// ZNVǂݍݏԂɑJ
				pSection = &( addSection() );				// ZNV𐶐
				break;
			}
			if( BUF_START_WITH( TAG_SECTION2_BEGIN ) ){		// ZNV(v2)Jn
				status = READ_SECTION2;						// ZNVǂݍݏԂɑJ
				pSection = &( addSection() );				// ZNV𐶐
				break;
			}
			if( BUF_START_WITH( TAG_FOLDER_BEGIN ) ){		// tH_Jn
				status = READ_FOLDER;						// tH_ǂݍݏԂɑJ
				Folder& nf = addFolder();					// tH_̍쐬Eǉ
				FolderStack.push( &nf );					// VtH_X^bNɋlށB
				break;
			}

			if( status == READ_HEADER ){					// wb_ǂݍݏԂȂ
				m_Header.push_back( &buf[0] );				// wb_ǉ
				iHeader ++;
			}
			break;

		case READ_FOLDER:				// tH_̓͏ԁiwb_[͏ԁj
		case READ_SECTION:				// ZNV̓͏ԁiwb_[͏ԁj
		case READ_SECTION2:				// ZNV(v2)̓͏ԁiwb_[͏ԁj
			// wb_[͂B
			{
				BaseElement* pElement 
					= (status == READ_FOLDER ) ?			// tH_͏ԂȂ
						(BaseElement*) FolderStack.top() :	// X^bN̓gpB
						(BaseElement*) pSection;			// Ȃ pSection gpB

				// wb_[̓
				pElement->setName( &buf[0] );				// O̓
				for( int i=0; RT_NEWLINE() != NULL; i++ ){	// Vs̃tFb`
					RT_HCOMP_MAKELOWERBUF();						// buf ̐`  strBufLwr ̍쐬

					if( BUF_START_WITH( "." ) ){			// wb_[̏I
						break;
					}else if( BUF_START_WITH( "note=" ) ){	// Vlf[^
						pElement->getAttributes().addNotes( String(&buf[0]+5) );
					}else{
						pElement->getAttributes().setAttribute( (Attributes::ID_T)i, &buf[0] );
															// wb_[̒ǉ
					}
				}
			}
			if( pRet == NULL ){								// s EOF oBO𔭍sB
				strException += "(at read-inner-header of ";// O̐ݒ
				strException += ( status == READ_FOLDER ) ? "folder)" : "section)";
				goto EXIT_READTREE;							// I
			}

			// wb_[̓́AIB̏ԂɑJځB
			// ̑Jڐݒ
			switch( status ) {
			case READ_FOLDER:	status = READ_FOLDER_CONTENTS;	break;	// FOLDER   -> FOLDER_CONTENTS
			case READ_SECTION:	status = READ_SECTION_CONTENTS;	break;	// SECTION  -> SECTION_CONTENTS
			case READ_SECTION2:	status = READ_SECTION2_CONTENTS;break;	// SECTION2 -> SECTION2_CONTENTS
			}
			break;

		case READ_FOLDER_CONTENTS:			// <s> -> <f> Ԃɖ߂Ƃ̃Gg|Cg
			// <s>, <s2>, <f>, </f> ԑJ
			for(;;){
				if( BUF_START_WITH( TAG_SECTION_BEGIN ) ){	// ZNVJn
					status = READ_SECTION;					// ZNVǂݍݏԂɑJ
					pSection = &( FolderStack.top()->addSection() );	// ZNV𐶐
					break;
				}
				if( BUF_START_WITH( TAG_SECTION2_BEGIN ) ){	// ZNV(v2)Jn
					status = READ_SECTION2;					// ZNVǂݍݏԂɑJ
					pSection = &( FolderStack.top()->addSection() );	// ZNV𐶐
					break;
				}
				if( BUF_START_WITH( TAG_FOLDER_BEGIN ) ){	// tH_Jn
					status = READ_FOLDER;					// tH_ǂݍݏԂɑJ
					Folder& nf = FolderStack.top()->addFolder();	// tH_̍쐬Eǉ
					FolderStack.push( &nf );				// VtH_X^bNɋlށB
					break;
				}
				if( BUF_START_WITH( TAG_FOLDER_END ) ){		// tH_I
					FolderStack.pop();						// X^bN|bv
					status = FolderStack.empty()	?		
								READ_ROOT			:		// X^bNȂ READ_ROOT ɑJ
								READ_FOLDER_CONTENTS;		// 󂶂Ȃ΃tH_͏ԂɑJ
					break;
				}

				RT_NEWLINE();								// Vs̃tFb`
				if( pRet == NULL ){							// s EOF oBO𔭍sB
					strException += "(in folder)";			// O̐ݒ
					goto EXIT_READTREE;						// I
				}
				RT_HCOMP_MAKELOWERBUF();					// buf ̐`  strBufLwr ̍쐬
			}
			break;

		case READ_SECTION_CONTENTS:							// ZNV̓e
			// </s> ԑJ
			for( ;; ){
				if( BUF_START_WITH( TAG_SECTION_END ) ){	// ZNVI
					status = FolderStack.empty()	?
								READ_ROOT			:		// X^bNȂ READ_ROOT ɑJ
								READ_FOLDER_CONTENTS;		// 󂶂Ȃ΃tH_͏ԂɑJ
					pSection = NULL;						// ZNV|C^NULLɖ߂B
					break;
				}
				Question q;
				Section::Parser::parseLine( q, &buf[0] );
				pSection->addQuestion( q );

				RT_NEWLINE();								// Vs̃tFb`
				if( pRet == NULL ){							// s EOF oBO𔭍sB
					strException += "(at section)";			// O̐ݒ
					goto EXIT_READTREE;						// I
				}
				RT_HCOMP_MAKELOWERBUF();					// buf ̐`  strBufLwr ̍쐬
			}
			break;

		case READ_SECTION2_CONTENTS:						// ZNV(v2)̓e
			// </s2> ԑJ
			{
				Question q;
				enum READ_SECTION2_STATUS {
					SEC2_ANSWERS = 0,	///< 𓚌Q
					SEC2_QUESTIONS,		///< Q
					SEC2_HINTS,			///< qgQ
					SEC2_OTHERS,		///< ̑̃f[^Q
					SEC2_EXTENDS,		///< gf[^Q
				}sec2_stat = SEC2_ANSWERS;
				int idx = 0;			// }镶Q̃CfbNX

				//  q 𐶐B".." ꂽ q  pSection ɒǉB
				for( ;; ){
					if( sec2_stat == SEC2_ANSWERS && idx == 0 ) {
						if( BUF_START_WITH( TAG_SECTION2_END ) ){	// ZNVI
							status = FolderStack.empty()	?
										READ_ROOT			:		// X^bNȂ READ_ROOT ɑJ
										READ_FOLDER_CONTENTS;		// 󂶂Ȃ΃tH_͏ԂɑJ
							pSection = NULL;						// ZNV|C^NULLɖ߂B
							break;
						}
					}

					// ".." Ȃ q ǉB
					if( strcmp( &buf[0], ".." ) == 0 ) {
						pSection->addQuestion( q );
						q.init();
						sec2_stat = SEC2_ANSWERS;
						idx = 0;
					}else{
						switch( sec2_stat ) {
						case SEC2_ANSWERS:		///< 𓚌Q
							if( strcmp( &buf[0], "." ) == 0 ){	sec2_stat = SEC2_QUESTIONS; idx=0; }
							else if( idx<q.nAnswerMax() ){		q.m_strAnswers[idx] = &buf[0]; idx++; }
							break;
						case SEC2_QUESTIONS:	///< Q
							if( strcmp( &buf[0], "." ) == 0 ){	sec2_stat = SEC2_HINTS;		idx=0; }
							else if( idx<q.nQuestionMax() ){	q.m_strQuestions[idx] = &buf[0]; idx++; }
							break;
						case SEC2_HINTS:		///< qgQ
							if( strcmp( &buf[0], "." ) == 0 ){	sec2_stat = SEC2_OTHERS;	idx=0; }
							else if( idx<q.nHintMax() ){		q.m_strHints[idx] = &buf[0]; idx++; }
							break;
						case SEC2_OTHERS:		///< ̑̃f[^Q
							if( strcmp( &buf[0], "." ) == 0 ){	sec2_stat = SEC2_EXTENDS;	idx=0; }
							else{
								// WAV t@Ĉ݂Ȃ̂ŁA߂Ŋi[B
								// ̗vfǉۂ index ̊ǗKvB
								q.m_strWavFile = &buf[0];
								idx++;
							}
							break;
						case SEC2_EXTENDS:		///< gf[^Q
							//  extends ɒǉB
							q.m_strExtends.push_back( &buf[0] );
							break;
						}
					}

					RT_NEWLINE();								// Vs̃tFb`
					if( pRet == NULL ){							// s EOF oBO𔭍sB
						strException += "(at section2)";			// O̐ݒ
						goto EXIT_READTREE;						// I
					}
					RT_HCOMP_MAKELOWERBUF();					// buf ̐`  strBufLwr ̍쐬
//					HChomp( &buf[0] );
				}
			}
			break;
		}
	}
EXIT_READTREE:

	if( status == READ_ROOT ){								// READ_ROOT  EOF Ȃ̂ŁA
		return true;										// I
	}else{													// READ_ROOT ȊO̓G[Ȃ̂ŁA
		return false;										// false
	}
}

inline ElementList::Element& 
ElementList::Element::operator = ( const ElementList::Element& a_from )
{
	m_Id = a_from.m_Id;
	if( m_Id == SECTION ){
		m_Element = new Section();
		*(Section*)m_Element = *(Section*)a_from.m_Element;
	}else{
		m_Element = new Folder();
		*(Folder*)m_Element = *(Folder*)a_from.m_Element;
	}
	return *this;
}

// tH_pX̌
// ݂ȂΗO throw B
inline Folder& 
Folder::getFolder( const String& a_Path )
{
#define	GETFOLDER_EXCEPTION_STRING		"folder " + a_Path + "not found."
	String strLeft, strRight;
	if( Tree::splitPathForward( a_Path, strLeft, strRight ) == false ){
		// '/' ܂܂ĂȂ
		// '/' pXɊ܂܂ĂȂ̂ŁÃtH_Ɋ܂܂ĂB
		try{
			return getFolder_atThisPoint( a_Path );
		}catch(...){
			throw PdbException( GETFOLDER_EXCEPTION_STRING );
		}
	}
	// '/' ܂܂ĂB

	// strLeft ̃tH_ɑ݂邩ǂ𒲂ׂB
	try{
		Folder& BaseFolder = getFolder_atThisPoint( strLeft );

		// ̃tH_AstrRight B
		try{
			return BaseFolder.getFolder( strRight );
		}catch(...){
			throw PdbException( GETFOLDER_EXCEPTION_STRING );
		}
	}catch(...){
		// tH_݂Ȃ̂ŁAO𓊂B
		throw PdbException( GETFOLDER_EXCEPTION_STRING );
	}
}

/// Line -> Input
inline bool
Section::Parser::parseLine( Question& q_, CSTR line_ )
{
	q_.init();												// oϐ
	if( line_ == NULL ) return false;

	if( strlen(line_) == 0 )	return false;				// Cf[^ݒ肳Ă邩ǂ̊mF
	if( isQuestionLine( line_ ) == false )	return false;	// f[^ǂ̊mF

	// ͂āAoϐɐݒ肷B
	return parse( q_, line_ );
}

/*
 * ?"a1","a2",a3,a4,a5,"q",...
 * ̌`͂āAoϐɐݒ肷B
 *
 * ?ans1,ans2,ans3,ans4,ans5,question,hints,dummy-datas
 */
inline bool 
Section::Parser::parse( Question& q_, CSTR a_line )
{
	int n;
	String	in(a_line);								// ͍s string \
	String	buf;									// obt@

	String::iterator it = in.begin();				// pCe[^
	it ++;												// ? ǂݔ΂
	bool		fEnd = false;
	
	for( n=0; n < N_ANSWERMAX+3; n++ )
	{
		if( it == in.end() ) break;
		String::size_type l = in.find_first_not_of( " \t" );	// 󔒂ǂݔ΂B
		if( l != String::npos ) 
			it += l;									// 󔒂ǂݔ΂B
		
		// '"' ǂm߂B
		if( *it == '"' ){
			// '"' Ȃ̂ŁA '"' \܂ł擾B
			if( !parseWQuotedString( in, it, buf ) ){	// '"' ɂ؂o
				return false;							// '"' Ő؂oȂB
			}
			it += buf.length() + 2;						// Q '"' ̕܂ށB
			// ',' ܂łǂݔ΂Ait ̎܂Ői߂B
			l = in.find( ',', it-in.begin() );
			if( l == String::npos ){					// ',' ȂB
				fEnd = true;
			}else{
				it = in.begin() + l + 1;				// ',' ̎ɐi߂
			}
		}else{
			// " ł͂Ȃ̂ŁA , \܂ł擾B
			l = in.find( ',', it-in.begin() );			// , T[`
			if( l == String::npos ){					// , ȂB
				fEnd = true;
				buf = a_line + (it-in.begin());
			}else{
				int first = (int)( it-in.begin() );
				buf = in.substr( first, l-first );		// , ̒O܂ł擾
				it += l-first + 1;						// ',' ̎ɐi߂B
			}
		}

		//
		// buf  CX^C̓X^C ϊB
		//
		TransStyle_Line2Input( buf );

		// 擾f[^oϐɊi[
		if( n < N_ANSWERMAX ){
			q_.m_strAnswers[ n ] = buf;
		}else if( n == 5 ){
			parseQuestion( q_, buf );
		}else if( n == 6 ){
			parseHint( q_, buf );
		}else if( n == 7 ){
			q_.m_strWavFile = buf;
		}

		if( fEnd ){
			return true;
		}
	}

	if( it != in.end() ){
		// ܂f[^̂ŁAgf[^ɂĂB
		q_.m_strExtends.push_back( a_line + (it-in.begin()) );
	}
	return true;
}

/**
 * w肳ꂽ in  it A'"' ň͂܂ꂽ w肳ꂽobt@ buf ɎoB
 * A͂܂ꂽ̂ \" ܂ނƂłB
 *
 * "xxx" ̂Axxx oAoԂB
 * Pڂ '"' łȂ΂ȂȂB
 *	
 * @param in	[in]  擾
 * @param it	[in]  Jnʒu
 * @param buf	[out] oi[obt@
 *
 * @return
 *	false	擾s
 *			'"'\O '\0'oAPڂ'"'łȂAȂ \n
 *	true	擾
 */
inline bool
Section::Parser::parseWQuotedString( const String& in, String::iterator it, String& buf )
{
	if( *it != '"' ) return false;
	buf.resize( 0 );
	
	++ it;		// '"' ǂݔ΂B
	
	// p[X
	while( it != in.end() ){
		// '"' łAPO̕ '\' łȂ΁A
		if( *it == '"' && *(it-1) != '\\' )break;
		buf += *it;
		++it;
	}
	if( it == in.end() )return false;
	
	return true;
}

/**
 * CX^C  ̓X^C ϊsB
 *
 * @return
 *	true	ϊ			\n
 *	false	ϊȂ
 */
inline bool 
Section::Parser::TransStyle_Line2Input( String& buf )
{
	int n = 0;	// ϊ

	// s/[^\]\n/\n/	邽߂ɁA\n  \a ɉϊB
		 HReplaceString( buf, "\\\\n", "\a" );		// dummy trans
	n += HReplaceString( buf, "\\n", "\r\n" );		// ( \n -> (sR[h) )
	n += HReplaceString( buf, "\\\"", "\"" );		// ( \" -> " )
	n += HReplaceString( buf, "\\\\", "\\" );		// ( \\ -> \ )
		 HReplaceString( buf, "\a", "\\n" );		// dummy rev-trans

	if( n > 0 ){
		return true;
	}
	return false;
}

/**
 * ̓X^C  CX^C ϊsB
 *
 * @return
 *	true	ϊ			\n
 *	false	ϊȂ
 */
inline bool 
Section::Parser::TransStyle_Input2Line( String& buf )
{
	int n = 0;	// ϊ

	n+= HReplaceString( buf, "\\", "\\\\" );		// ( \ -> \\ )
	n+= HReplaceString( buf, "\"", "\\\"" );		// ( " -> \" )
	n+= HReplaceString( buf, "\r\n", "\\n" );		// ( (sR[h) -> \n )
	
	// buf  ',' ܂܂Ă΁A'"' ň͂ށB
	if( buf.find( ',' ) != buf.npos ){
		// ',' ܂܂Ă̂ŁA'"'ň͂ށB
		buf.insert( 0, "\"" );
		buf += '"';
		n++;	// ϊ񐔂CNg
	}

	if( n > 0 ){
		return true;
	}
	return false;
}

/**
 * Ɏw肳ꂽwf[^xAN_QUESTIONMAX  m_szQuestion 
 * WJEi[B
 * 
 * Ɏw肳ꂽf[^́A\r\n ŕ̕ɋ؂ĂB
 * @note QswłȂB
 */
#ifdef	WIN32
#	define	RETURN_CODE_STR	"\r\n"
#	define	RETURN_CODE_LEN 2
#else
#	define	RETURN_CODE_STR	"\n"
#	define	RETURN_CODE_LEN 1
#endif
inline bool 
Section::Parser::parseQuestion( Question& q_, const String& in )
{
	String::size_type i;
	if( (i=in.find( RETURN_CODE_STR )) == in.npos ){
		// RETURN_CODE_STR not found
		q_.m_strQuestions[0] = in;
	}else{
		// found
		q_.m_strQuestions[0] = in.substr( 0, i );
		q_.m_strQuestions[1] = in.substr( i+RETURN_CODE_LEN );
	}
	
	return true;
}

/**
 * Ɏw肳ꂽwqgf[^xAN_HINTMAX ̕
 * WJEi[B
 *
 * Ɏw肳ꂽf[^́ARETURN_CODE_STR ŕ̕
 * ؂ĂB
 * @note RswłȂB
 */
inline bool
Section::Parser::parseHint( Question& q_, const String& in )
{
	String::size_type i;
	if( (i=in.find( RETURN_CODE_STR )) == in.npos ){
		// RETURN_CODE_STR not found
		q_.m_strHints[0] = in;
	}else{
		// found
		q_.m_strHints[0] = in.substr( 0, i );

		// ɁB
		String::size_type k;
		if( (k=in.find( RETURN_CODE_STR, i+RETURN_CODE_LEN )) == in.npos ){
			// RETURN_CODE_STR not found
			q_.m_strHints[1] = in.substr( i+RETURN_CODE_LEN );
		}else{
			// found
			q_.m_strHints[1] = in.substr( i+RETURN_CODE_LEN, k );
			q_.m_strHints[2] = in.substr( k+RETURN_CODE_LEN );
		}
	}
	
	return true;
}

/// Input -> Line
inline bool	
Section::Parser::makeLine( const Question& q_, String& linebuf_ )
{
	if( q_.isEmpty() ){
		linebuf_ = "";
		return true;
	}

	// Rgs̏ꍇ́A[0] ̂ݖߍށB
	bool bCommentLine = q_.isCommentLine();
	if( bCommentLine ){
		linebuf_ = q_.getAnswer(0);
		return true;
	}

	linebuf_ = "?";

	// w𓚁x̖ߍ
	String buf;
	int i;
	for( i=0; i<N_ANSWERMAX; i++ ){
		buf = q_.getAnswer(i);
		TransStyle_Input2Line( buf );
		linebuf_ += buf;
		linebuf_ += ",";
	}
	
	// wx̖ߍ
	String qstr("");			// f[^̘A
	for( i=0; i<N_QUESTIONMAX; i++ ){
		buf = q_.getQuestion(i);
		if( i>0 && buf.empty() == false ){	// ؂
			qstr += RETURN_CODE_STR;		// TransStyle_Input2Line  \r\n -> \\n ϊB
		}
		qstr += buf;
	}
	TransStyle_Input2Line( qstr );
	linebuf_ += qstr;
	linebuf_ += ",";

	// wqgx̖ߍ
	qstr="";
	for( i=0; i<N_HINTMAX; i++ ){
		buf = q_.getHint(i);
		if( i>0 && buf.empty() == false ){	// ؂
			qstr += RETURN_CODE_STR;		// TransStyle_Input2Line  \r\n -> \\n ϊB
		}
		qstr += buf;
	}
	TransStyle_Input2Line( qstr );
	linebuf_ += qstr;
	linebuf_ += ",";

	// WAVt@C̖ߍ
	linebuf_ += q_.m_strWavFile;
	linebuf_ += ",";

	// gf[^̖ߍ
	if( q_.nExtends() != 0 ) {
		for( int i=0; i<q_.nExtends(); i++ ) {
			if( i>0 ) {
				linebuf_ += ",";
			}
			linebuf_ += q_.getExtendData(i);
		}
	}

	return true;
}

inline Question/*&*/ 
Section::getQuestion( int a_idx ) const
{
//	Question q;
//	Parser::parseLine( q, m_Lines[a_idx].c_str() );
//	return q;
	return m_QuestionList[a_idx];
}

inline bool 
QuestionIndex::makeIndex( const Section& sec_ )
{
	for( int i=0; i<sec_.nLines(); i++ ){
		pdb::Question q = sec_.getQuestion(i);
		if( q.isQuestionLine() ) {
			index_.push_back( i );
		}
	}
	return true;
}

inline bool 
Section::setQuestion( int idx_, const Question& q_ )
{
	// E`FbN
	if( idx_ < 0 || idx_ >= nLines() )
		return false;
	m_QuestionList[ idx_ ] = q_;
	return true;
}

inline bool 
Section::writeTo( FILE* a_fp, int nVersion_/* = 300*/ )
{
	if( nVersion_ >= 400 ) {
		// <s2> ŏo͂B
		fprintf( a_fp, "%s\n", TAG_SECTION2_BEGIN );// ZNVJnL ̏o
		BaseElement::writeTo( a_fp );				// OȀo

		// ZNV̗vf̏o
		Questions::const_iterator it	 = m_QuestionList.begin();
		Questions::const_iterator it_end = m_QuestionList.end();

		for( ; it != it_end; it ++ ){
			const Question& q = *it;
			// 𓚌Q
			for( int i=0; i<q.nAnswer(); i++ )
				fprintf( a_fp, "%s\n", q.getAnswer(i).c_str() );
			fprintf( a_fp, ".\n" );
			// Q
			for( int i=0; i<q.nQuestion(); i++ )
				fprintf( a_fp, "%s\n", q.getQuestion(i).c_str() );
			fprintf( a_fp, ".\n" );
			// qgQ
			for( int i=0; i<q.nHint(); i++ )
				fprintf( a_fp, "%s\n", q.getHint(i).c_str() );
			fprintf( a_fp, ".\n" );
			// ̑̃f[^Q
			fprintf( a_fp, "%s\n", q.getWavFilename().c_str() );
			fprintf( a_fp, ".\n" );
			// gf[^Q
			for( int i=0; i<q.nExtends(); i++ )
				fprintf( a_fp, "%s\n", q.getExtendData(i).c_str() );
			// IL
			fprintf( a_fp, "..\n" );
		}

		fprintf( a_fp, "%s\n\n", TAG_SECTION2_END );	// ZNVIL ̏o
	}else{
		fprintf( a_fp, "%s\n", TAG_SECTION_BEGIN );	// ZNVJnL ̏o
		BaseElement::writeTo( a_fp );				// OȀo

		// ZNV̗vf̏o
		Questions::const_iterator it	 = m_QuestionList.begin();
		Questions::const_iterator it_end = m_QuestionList.end();

		for( ; it != it_end; it ++ ){
			String s;
			Parser::makeLine( *it, s );
			fprintf( a_fp, "%s\n", s.c_str() );
		}

		fprintf( a_fp, "%s\n\n", TAG_SECTION_END );	// ZNVIL ̏o
	}

	return true;
}

inline bool 
Section::deleteLine( int a_idx )
{
	int n = (int)m_QuestionList.size();
	if( a_idx == n-1 ){	// Ȃ̂ Pop B
		m_QuestionList.pop_back();
		return true;
	}
	if( 0 <= a_idx && a_idx < n ){			// ͈͓Ȃ̂ 폜B
		m_QuestionList.erase( m_QuestionList.begin() + a_idx );
		return true;
	}
	return false;
}

inline bool 
Section::insertQuestion( int a_idx, Question& q_ )
{
	if( a_idx < 0 )
		return false;
	int n = (int)m_QuestionList.size();
	if( a_idx > n-1 ){	// iȍ~jȂ̂ Push B
		m_QuestionList.push_back( q_ );
		return true;
	}
	// w肳ꂽCfNXɑ}B
	m_QuestionList.insert( m_QuestionList.begin()+a_idx, q_ );
	return true;
}

}//namespace pdb

#endif
