// $Id: hcom.h,v 1.1.1.1 2002/11/16 16:02:36 halts Exp $
/* HComLib - Halts Common Library 
 * Copyright (C) 2001 Halts (TAKEUCHI Hiroaki) .
 */

#ifndef ___HCOM_H_INCLUDED_
#define ___HCOM_H_INCLUDED_

//--------------------------------------------------------------------
//----- include header files

#ifdef HAVE_CONFIG_H
#	include "cpssconfig.h"
#endif

#include <string>				///< use std::string
#include <algorithm>			///< use algorithm
#include <vector>
#ifdef HAVE_UNISTD_H
#	include <unistd.h>			///< unlink() ...
#endif

//----- ShiftJIS }N
#define iskanji(c)	((c)>=0x81 && (c)<=0x9F || (c)>=0xE0 && (c)<=0xFC)	// Shift-JIS 1 Byte
#define iskanji2(c)	((c)>=0x40 && (c)<=0xFC && (c) != 0x7F)				// Shift-JIS 2 Byte

//----- typedef
typedef unsigned int			u_int;			///< JE^Ȃǂ̌^

#ifndef	WIN32
#ifdef	_UNICODE
typedef const wchar_t*			LPCTSTR;		///< 萔
#else	// _UNICODE
typedef const char*				LPCTSTR;		///< 萔
#endif	// _UNICODE
#endif

//--------------------------------------------------------------------
//----- for Windows Platform
#include "hcom_win.h"

//--------------------------------------------------------------------
//----- prototype-declarations
bool				HFileExist( LPCTSTR lpFileName );
inline 	char *		HFGets( char *buf, int buflen, FILE *fp );	///< chomp t fgets()

//--------------------------------------------------------------------
//----- implementations for inline functions

/** 
 * ̒u
 * @param in 	Ώە
 * @param pat 	u镶
 * @param rep	u̕
 */
inline int HReplaceString( std::string& in, const char* pat, const char* rep )
{
	// ǂɂ邩T
	int n = 0;								// u
	int lenPat = (int)strlen(pat);
	int lenRep = (int)strlen(rep);

	for( u_int i=0; i<in.size(); ){
		if( strncmp( &in[i], pat, lenPat ) == 0 ){
			// 
			in.replace( i, lenPat, rep );
			i += lenRep;
			n++;
		}else{
			if( iskanji( (unsigned char)in[i] ) ){	// ShiftJIS PoCgڂȂAǂݔ΂B
				i += 2;
			}else{
				i++;
			}
		}
	}

	return n;
}

///  CR(+LF) 폜B
inline bool HChomp( char * a_buf )
{
	int len = (int)strlen(a_buf);
	if( len <= 0 )return false;
	if( a_buf[len-1] == '\n' )
		a_buf[len-1] = '\0';
	if( len>=2 && 
		a_buf[len-2] == '\r' ) {
		a_buf[len-2] = '\0';
	}
	return true;
}

/// ̑啶
static inline char
upper_ch( const char c )
{
	return static_cast<char>( toupper( c ) );
}

/** 
 * ̑啶
 * @param s1 ͕
 * @param s2 o͕
 */
inline std::string &
HUpperString( const std::string &s1, std::string &s2 )
{
	s2 = s1;
	std::transform( s1.begin(), s1.end(), s2.begin(), upper_ch );
	return s2;
}

/// 
static inline char
lower_ch( const char c )
{
	return static_cast<char>( tolower( c ) );
}

/** 
 * ̏
 * @param s1 ͕
 * @param s2 o͕
 */
inline std::string &
HLowerString( const std::string &s1, std::string &s2 )
{
	s2 = s1;
	std::transform( s1.begin(), s1.end(), s2.begin(), lower_ch );
	return s2;
}

/// chomp t fgets() 
inline 	char *		HFGets( char *buf, int buflen, FILE *fp )
{
	if( fgets( buf, buflen, fp )==NULL )
		return NULL;

	HChomp( buf );
	return buf;
}



#endif	// ___HCOM_H_INCLUDED_
